=== debian/changelog ===
xeus-python (0.8.6-2) unstable; urgency=medium

  * Patch CMakeLists to actually respect XPYT_DISABLE_MTUNE_GENERIC, which was
    causing build failures on most non-x86 architectures

 -- Gordon Ball <gordon@chronitis.net>  Fri, 30 Oct 2020 09:11:31 +0000

xeus-python (0.8.6-1) unstable; urgency=medium

  * Initial release. (Closes: #973043)

 -- Gordon Ball <gordon@chronitis.net>  Wed, 28 Oct 2020 16:17:17 +0000
