=== debian/control ===
Source: xeus-python
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               xeus-dev,
               pybind11-dev,
               pybind11-json-dev,
               python3-dev,
Standards-Version: 4.5.0
Section: science
Homepage: https://github.com/jupyter-xeus/xeus-python
Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus-python
Rules-Requires-Root: no

Package: xeus-python-dev
Architecture: any
Depends: ${misc:Depends},
         libxeus-python0 (= ${binary:Version}),
         xeus-dev,
         pybind11-dev,
         pybind11-json-dev,
         python3-dev,
Description: Native jupyter kernel for python (headers)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the development headers.

Package: libxeus-python0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: Native jupyter kernel for python (library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the library.

Package: xpython
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3-jedi,
         python3-pygments,
Recommends: python3-ipython
Description: Native jupyter kernel for python (binary)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the xpython executable and jupyter kernel configuration.
