## xeus-python 0.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,7 +69,7 @@
 # Dependencies
 # ============
 
-set(xeus_REQUIRED_VERSION 0.24.0)
+set(xeus_REQUIRED_VERSION 0.25.0)
 set(pybind11_REQUIRED_VERSION 2.2.4)
 set(pybind11_json_REQUIRED_VERSION 0.2.2)
 
@@ -97,7 +97,7 @@
 
 if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder")
-    if (XPYT_DISABLE_ARCH_NATIVE)
+    if (XPYT_DISABLE_ARCH_NATIVE AND NOT XPYT_DISABLE_TUNE_GENERIC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mtune=generic")
     elseif (XPYT_DISABLE_TUNE_GENERIC)
         set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
@@ -118,9 +118,9 @@
 # ============
 
 set(XEUS_PYTHON_SRC
-    src/xcomm.cpp
-    src/xcomm.hpp
     src/xdebugger.cpp
+    src/xdebugpy_client.hpp
+    src/xdebugpy_client.cpp
     src/xdisplay.cpp
     src/xdisplay.hpp
     src/xinput.cpp
@@ -136,8 +136,8 @@
     src/xlinecache.hpp
     src/xnullcontext.cpp
     src/xnullcontext.hpp
-    src/xptvsd_client.cpp
-    src/xptvsd_client.hpp
+    src/xpython_kernel.cpp
+    src/xpython_kernel.hpp
     src/xstream.cpp
     src/xstream.hpp
     src/xtraceback.cpp
@@ -184,7 +184,7 @@
         CMAKE_CXX_COMPILER_ID MATCHES "Intel")
 
         target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
-    
+
         # Mtune generic/native
         if (XPYT_DISABLE_ARCH_NATIVE AND NOT XPYT_DISABLE_TUNE_GENERIC)
             target_compile_options(${target_name} PUBLIC -mtune=generic)
@@ -344,8 +344,4 @@
     if (XEUS_PYTHONHOME_RELPATH)
         target_compile_definitions(xpython PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
     endif()
-endif()
-
-# xpython_extension
-# =================
-
+
