=== debian/changelog ===
xeus-python (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0
  * Drop XPYT_DISABLE_TUNE_GENERIC patch, applied upstream
  * Add explicit build-dependencies on nlohmann-json-dev, libzmq3-dev, xtl-dev
    rather than relying on transitive dependencies

 -- Gordon Ball <gordon@chronitis.net>  Fri, 20 Nov 2020 20:59:55 +0000
