=== debian/control ===
--- 
+++ 
@@ -5,9 +5,12 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                pkg-config,
-               xeus-dev,
-               pybind11-dev,
-               pybind11-json-dev,
+               libzmq3-dev,
+               xeus-dev (>= 0.25~),
+               xtl-dev (>= 0.6.8~),
+               nlohmann-json3-dev (>= 3.6.1~),
+               pybind11-dev (>= 2.2.4~),
+               pybind11-json-dev (>= 0.2.6~),
                python3-dev,
 Standards-Version: 4.5.0
 Section: science
