## xeus-python 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -129,6 +129,8 @@
     src/xinspect.hpp
     src/xinteractiveshell.cpp
     src/xinteractiveshell.hpp
+    src/xinternal_utils.cpp
+    src/xinternal_utils.hpp
     src/xinterpreter.cpp
     src/xis_complete.cpp
     src/xis_complete.hpp
@@ -141,15 +143,15 @@
     src/xstream.cpp
     src/xstream.hpp
     src/xtraceback.cpp
-    src/xtraceback.hpp
     src/xutils.cpp
-    src/xutils.hpp
 )
 
 set(XEUS_PYTHON_HEADERS
     include/xeus-python/xdebugger.hpp
     include/xeus-python/xeus_python_config.hpp
     include/xeus-python/xinterpreter.hpp
+    include/xeus-python/xtraceback.hpp
+    include/xeus-python/xutils.hpp
 )
 
 set(XPYTHON_SRC
@@ -200,33 +202,6 @@
         else ()
             message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
         endif ()
-
-        # Enable link time optimization and set the default symbol
-        # visibility to hidden (very important to obtain small binaries)
-        if (NOT ${U_CMAKE_BUILD_TYPE} MATCHES DEBUG)
-            # Check for Link Time Optimization support
-            # (GCC/Clang)
-            CHECK_CXX_COMPILER_FLAG("-flto" HAS_LTO_FLAG)
-            if (HAS_LTO_FLAG)
-                target_compile_options(${target_name} PUBLIC -flto)
-            endif ()
-
-            # Avoids removing symbols from the static library
-            CHECK_CXX_COMPILER_FLAG("-ffat-lto-objects" HAS_FATLTO_FLAG)
-            if (${linkage_upper} MATCHES "STATIC" AND  HAS_FATLTO_FLAG)
-                message(STATUS "ENABLE FAT LTO OBJECTS")
-                target_compile_options(${target_name} PUBLIC -ffat-lto-objects)
-            endif ()
-
-            # Intel equivalent to LTO is called IPO
-            if (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-                CHECK_CXX_COMPILER_FLAG("-ipo" HAS_IPO_FLAG)
-                if (HAS_IPO_FLAG)
-                    target_compile_options(${target_name} PUBLIC -ipo)
-                endif ()
-            endif ()
-        endif ()
-
     endif ()
 
     if (APPLE)
@@ -345,3 +320,41 @@
         target_compile_definitions(xpython PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
     endif()
 
+    target_compile_definitions(xpython PRIVATE XEUS_PYTHON_EXECUTABLE="${PYTHON_EXECUTABLE}")
+endif()
+
+# xpython_extension
+# =================
+
+if (XPYT_BUILD_XPYTHON_EXTENSION)
+    pybind11_add_module(xpython_extension ${XPYTHON_EXTENSION_SRC})
+
+    xpyt_set_common_options(xpython_extension)
+    xpyt_set_kernel_options(xpython_extension)
+endif()
+
+# Tests
+# =====
+
+if(XPYT_DOWNLOAD_GTEST OR XPYT_GTEST_SRC_DIR)
+    set(XPYT_BUILD_TESTS ON)
+endif()
+
+if(XPYT_BUILD_TESTS)
+    add_subdirectory(test)
+endif()
+
+# Installation
+# ============
+
+include(CMakePackageConfigHelpers)
+
+set(XEUS_PYTHON_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for xeus-pythonConfig.cmake")
+
+# Install xeus-python and xeus-python-static
+if (XPYT_BUILD_SHARED)
+    install(TARGETS ${XEUS_PYTHON_TARGETS}
+            EXPORT ${PROJECT_NAME}-targets
+            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
