=== debian/changelog ===
xeus-python (0.9.2-1) unstable; urgency=medium

  * New upstream version 0.9.2
  * Rebase patches, increment versioned dependency on xeus-dev

 -- Gordon Ball <gordon@chronitis.net>  Fri, 11 Dec 2020 13:00:27 +0000
