=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                cmake,
                pkg-config,
                libzmq3-dev,
-               xeus-dev (>= 0.25~),
+               xeus-dev (>= 0.25.3~),
                xtl-dev (>= 0.6.8~),
                nlohmann-json3-dev (>= 3.6.1~),
                pybind11-dev (>= 2.2.4~),
