=== debian/changelog ===
xeus-python (0.9.5-1) unstable; urgency=medium

  * New upstream version 0.9.5
  * Depend upon xtl-dev 0.6.23

 -- Gordon Ball <gordon@chronitis.net>  Tue, 12 Jan 2021 19:05:47 +0000
