=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                pkg-config,
                libzmq3-dev,
                xeus-dev (>= 0.25.3~),
-               xtl-dev (>= 0.6.8~),
+               xtl-dev (>= 0.6.23~),
                nlohmann-json3-dev (>= 3.6.1~),
                pybind11-dev (>= 2.2.4~),
                pybind11-json-dev (>= 0.2.6~),
