=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-python/tags .*/archive/([\d\.-]+)\.tar\.gz
