## xeus-python 0.12.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -72,7 +72,7 @@
 set(xtl_REQUIRED_VERSION 0.6.23)
 set(xeus_REQUIRED_VERSION 0.25.0)
 set(pybind11_REQUIRED_VERSION 2.6.0)
-set(pybind11_json_REQUIRED_VERSION 0.2.2)
+set(pybind11_json_REQUIRED_VERSION 0.2.8)
 
 if (NOT TARGET xtl)
     find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
@@ -80,7 +80,7 @@
 if (NOT TARGET xeus AND NOT TARGET xeus-static)
     find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
 endif ()
-if (NOT TARGET pybind11)
+if (NOT TARGET pybind11::headers)
     find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
 endif ()
 if (NOT TARGET pybind11_json)
@@ -91,8 +91,6 @@
 # =====
 
 include(CheckCXXCompilerFlag)
-
-set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
 
 if (MSVC)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4141")
@@ -122,6 +120,10 @@
 # ============
 
 set(XEUS_PYTHON_SRC
+    src/xcomm.cpp
+    src/xcomm.hpp
+    src/xcompiler.cpp
+    src/xcompiler.hpp
     src/xdebugger.cpp
     src/xdebugpy_client.hpp
     src/xdebugpy_client.cpp
@@ -129,22 +131,10 @@
     src/xdisplay.hpp
     src/xinput.cpp
     src/xinput.hpp
-    src/xinspect.cpp
-    src/xinspect.hpp
-    src/xinteractiveshell.cpp
-    src/xinteractiveshell.hpp
     src/xinternal_utils.cpp
     src/xinternal_utils.hpp
     src/xinterpreter.cpp
-    src/xis_complete.cpp
-    src/xis_complete.hpp
-    src/xlinecache.cpp
-    src/xlinecache.hpp
-    src/xnullcontext.cpp
-    src/xnullcontext.hpp
     src/xpaths.cpp
-    src/xpython_kernel.cpp
-    src/xpython_kernel.hpp
     src/xstream.cpp
     src/xstream.hpp
     src/xtraceback.cpp
@@ -358,3 +348,12 @@
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
             LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xeus-python)
+
+    # Makes the project importable from the build directory
+    export(EXPORT ${PROJECT_NAME}-targets
+           FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
+endif ()
+
+# Install xpython
+if (XPYT_BUILD_XPYTHON_EXECUTABLE)
