=== debian/changelog ===
xeus-python (0.12.5-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 14:02:06 +0000

xeus-python (0.12.5-1) unstable; urgency=medium

  * d/watch: new github tarball URL
  * Rebase patches
  * d/control: bump xeus, xtl, pybind11-json dependencies
  * New upstream version 0.12.5

 -- Gordon Ball <gordon@chronitis.net>  Sat, 09 Oct 2021 21:40:01 +0000
