=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
                cmake,
                pkg-config,
                libzmq3-dev,
-               xeus-dev (>= 0.25.3~),
-               xtl-dev (>= 0.6.23~),
+               xeus-dev (>= 1.0~),
+               xtl-dev (>= 0.7~),
                nlohmann-json3-dev (>= 3.6.1~),
                pybind11-dev (>= 2.2.4~),
-               pybind11-json-dev (>= 0.2.6~),
+               pybind11-json-dev (>= 0.2.8~),
                python3-dev,
 Standards-Version: 4.5.0
 Section: science
