=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-python/tags .*/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@
