## xeus-python 0.14.3+~0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,11 +45,16 @@
     "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
     "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
 )
+configure_file (
+    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
+    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
+)
 
 # Build options
 # =============
 
 # Compilation options
+
 OPTION(XPYT_DISABLE_ARCH_NATIVE "disable -march=native flag" OFF)
 OPTION(XPYT_DISABLE_TUNE_GENERIC "disable -mtune=generic flag" OFF)
 OPTION(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
@@ -62,17 +67,36 @@
 OPTION(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
 OPTION(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
 
+OPTION(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
+
 # Test options
 OPTION(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
 OPTION(XPYT_DOWNLOAD_GTEST "build gtest from downloaded sources" OFF)
 
+if(XPYT_EMSCRIPTEN_WASM_BUILD)
+    configure_file(wasm_patches/post.js ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
+
+    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
+
+    set(XPYT_DISABLE_ARCH_NATIVE ON)
+    set(XPYT_BUILD_STATIC OFF)
+    set(XPYT_BUILD_SHARED OFF)
+    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
+    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
+    set(XPYT_USE_SHARED_XEUS OFF)
+    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
+    set(XPYT_BUILD_TESTS OFF)
+    set(XPYT_DOWNLOAD_GTEST OFF)
+endif()
+
 # Dependencies
 # ============
 
-set(xtl_REQUIRED_VERSION 0.6.23)
-set(xeus_REQUIRED_VERSION 0.25.0)
-set(pybind11_REQUIRED_VERSION 2.6.0)
+set(xtl_REQUIRED_VERSION 0.7.0)
+set(xeus_REQUIRED_VERSION 2.0.0)
+set(pybind11_REQUIRED_VERSION 2.6.1)
 set(pybind11_json_REQUIRED_VERSION 0.2.8)
+set(pyjs_REQUIRED_VERSION 0.7.0)
 
 if (NOT TARGET xtl)
     find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
@@ -86,6 +110,13 @@
 if (NOT TARGET pybind11_json)
     find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
 endif ()
+
+if(XPYT_EMSCRIPTEN_WASM_BUILD)
+    if (NOT TARGET pyjs)
+        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
+    endif ()
+    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
+endif()
 
 # Flags
 # =====
@@ -122,8 +153,6 @@
 set(XEUS_PYTHON_SRC
     src/xcomm.cpp
     src/xcomm.hpp
-    src/xcompiler.cpp
-    src/xcompiler.hpp
     src/xdebugger.cpp
     src/xdebugpy_client.hpp
     src/xdebugpy_client.cpp
@@ -131,9 +160,14 @@
     src/xdisplay.hpp
     src/xinput.cpp
     src/xinput.hpp
+    src/xinspect.cpp
+    src/xinspect.hpp
     src/xinternal_utils.cpp
     src/xinternal_utils.hpp
     src/xinterpreter.cpp
+    src/xinterpreter_raw.cpp
+    src/xkernel.cpp
+    src/xkernel.hpp
     src/xpaths.cpp
     src/xstream.cpp
     src/xstream.hpp
@@ -146,6 +180,7 @@
     include/xeus-python/xeus_python_config.hpp
     include/xeus-python/xpaths.hpp
     include/xeus-python/xinterpreter.hpp
+    include/xeus-python/xinterpreter_raw.hpp
     include/xeus-python/xtraceback.hpp
     include/xeus-python/xutils.hpp
 )
@@ -158,14 +193,48 @@
     src/xpython_extension.cpp
 )
 
+set(XEUS_PYTHON_WASM_SRC
+    src/xcomm.cpp
+    src/xcomm.hpp
+    src/xdisplay.cpp
+    src/xdisplay.hpp
+    src/xinput.cpp
+    src/xinput.hpp
+    src/xinspect.cpp
+    src/xinspect.hpp
+    src/xinternal_utils.cpp
+    src/xinternal_utils.hpp
+    src/xinterpreter.cpp
+    src/xinterpreter_wasm.cpp
+    src/xkernel.cpp
+    src/xkernel.hpp
+    src/xpaths.cpp
+    src/xstream.cpp
+    src/xstream.hpp
+    src/xtraceback.cpp
+    src/xutils.cpp
+)
+
+set(XEUS_PYTHON_WASM_HEADERS
+    include/xeus-python/xdebugger.hpp
+    include/xeus-python/xeus_python_config.hpp
+    include/xeus-python/xpaths.hpp
+    include/xeus-python/xinterpreter.hpp
+    include/xeus-python/xinterpreter_wasm.hpp
+    include/xeus-python/xtraceback.hpp
+    include/xeus-python/xutils.hpp
+)
+
+set(XPYTHON_WASM_SRC
+    src/main_wasm.cpp
+)
+
 # Targets and link - Macros
 # =========================
 
 include(CheckCXXCompilerFlag)
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)
-
-set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib; ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
 
 macro(xpyt_set_common_options target_name)
     if (MSVC)
@@ -195,21 +264,6 @@
             message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
         endif ()
     endif ()
-
-    if (APPLE)
-        set_target_properties(${target_name} PROPERTIES
-            MACOSX_RPATH ON
-        )
-    else ()
-        set_target_properties(${target_name} PROPERTIES
-            BUILD_WITH_INSTALL_RPATH 1
-            SKIP_BUILD_RPATH FALSE
-        )
-    endif ()
-
-    set_target_properties(${target_name} PROPERTIES
-        INSTALL_RPATH_USE_LINK_PATH TRUE
-    )
 endmacro()
 
 # Common macro kernels (xpython and xpython_extension)
@@ -218,7 +272,10 @@
         message(STATUS "Enabling PyPI warning for target: " ${target_name})
         target_compile_definitions(${target_name} PRIVATE XEUS_PYTHON_PYPI_WARNING)
     endif()
-
+endmacro()
+
+# Common macro for linking targets
+macro(xpyt_target_link_libraries target_name)
     if (XPYT_USE_SHARED_XEUS_PYTHON)
         target_link_libraries(${target_name} PRIVATE xeus-python)
 
@@ -231,21 +288,22 @@
 
     find_package(Threads) # TODO: add Threads as a dependence of xeus or xeus-static?
     target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
+    set_target_properties(${target_name} PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
 endmacro()
 
 # Common macro for shared and static library xeus-python
-macro(xpyt_create_target target_name linkage output_name)
+macro(xpyt_create_target target_name src headers linkage output_name)
     string(TOUPPER "${linkage}" linkage_upper)
 
     if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
         message(FATAL_ERROR "Invalid library linkage: ${linkage}")
     endif ()
 
-    add_library(${target_name} ${linkage_upper} ${XEUS_PYTHON_SRC} ${XEUS_PYTHON_HEADERS})
+    add_library(${target_name} ${linkage_upper} ${src} ${headers})
     xpyt_set_common_options(${target_name})
 
     set_target_properties(${target_name} PROPERTIES
-                          PUBLIC_HEADER "${XEUS_PYTHON_HEADERS}"
+                          PUBLIC_HEADER "${headers}"
                           PREFIX ""
                           VERSION ${${PROJECT_NAME}_VERSION}
                           SOVERSION ${XPYT_VERSION_MAJOR}
@@ -277,8 +335,10 @@
 
     if (XEUS_PYTHONHOME_RELPATH)
         target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
-    endif()
-endmacro()
+    elseif (XEUS_PYTHONHOME_ABSPATH)
+        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_ABSPATH=${XEUS_PYTHONHOME_ABSPATH})
+    endif ()
+endmacro ()
 
 # xeus-python
 # ===========
@@ -287,73 +347,9 @@
 
 if (XPYT_BUILD_SHARED)
     # Build libraries
-    xpyt_create_target(xeus-python SHARED xeus-python)
+    xpyt_create_target(xeus-python "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" SHARED xeus-python)
     list(APPEND XEUS_PYTHON_TARGETS xeus-python)
 endif ()
 
 if (XPYT_BUILD_STATIC)
     # On Windows, a static library should use a different output name
-    # to avoid the conflict with the import library of a shared one.
-    if (CMAKE_HOST_WIN32)
-        xpyt_create_target(xeus-python-static STATIC xeus-python-static)
-    else ()
-        xpyt_create_target(xeus-python-static STATIC xeus-python)
-    endif ()
-    list(APPEND XEUS_PYTHON_TARGETS xeus-python-static)
-endif ()
-
-# xpython
-# =======
-
-if (XPYT_BUILD_XPYTHON_EXECUTABLE)
-    add_executable(xpython ${XPYTHON_SRC})
-    target_link_libraries(xpython PRIVATE pybind11::embed)
-
-    xpyt_set_common_options(xpython)
-    xpyt_set_kernel_options(xpython)
-endif()
-
-# xpython_extension
-# =================
-
-if (XPYT_BUILD_XPYTHON_EXTENSION)
-    pybind11_add_module(xpython_extension ${XPYTHON_EXTENSION_SRC})
-
-    xpyt_set_common_options(xpython_extension)
-    xpyt_set_kernel_options(xpython_extension)
-endif()
-
-# Tests
-# =====
-
-if(XPYT_DOWNLOAD_GTEST OR XPYT_GTEST_SRC_DIR)
-    set(XPYT_BUILD_TESTS ON)
-endif()
-
-if(XPYT_BUILD_TESTS)
-    add_subdirectory(test)
-endif()
-
-# Installation
-# ============
-
-include(CMakePackageConfigHelpers)
-
-set(XEUS_PYTHON_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for xeus-pythonConfig.cmake")
-
-# Install xeus-python and xeus-python-static
-if (XPYT_BUILD_SHARED)
-    install(TARGETS ${XEUS_PYTHON_TARGETS}
-            EXPORT ${PROJECT_NAME}-targets
-            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xeus-python)
-
-    # Makes the project importable from the build directory
-    export(EXPORT ${PROJECT_NAME}-targets
-           FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")
-endif ()
-
-# Install xpython
-if (XPYT_BUILD_XPYTHON_EXECUTABLE)
