=== debian/changelog ===
xeus-python (0.14.3+~0.5.0-3) unstable; urgency=medium

  * Standards-Version: 4.6.2
  * Rebuild against pybind11-dev >= 2.10.3

 -- Gordon Ball <gordon@chronitis.net>  Sat, 04 Feb 2023 20:51:31 +0000

xeus-python (0.14.3+~0.5.0-2) unstable; urgency=medium

  * Upload to unstable
  * Closes: #1016240

 -- Gordon Ball <gordon@chronitis.net>  Sat, 01 Oct 2022 21:04:47 +0000

xeus-python (0.14.3+~0.5.0-1) experimental; urgency=medium

  * Set CMAKE_BUILD_RPATH_USE_ORIGIN (reproducible builds, patch from Vagrant
    Cascadian). Closes: #1001860
  * Standards-Version: 4.6.0
  * New upstream version 0.14.3
    - Add component xeus-python-shell @ 0.5.0
  * New binary python3-xeus-python-shell

 -- Gordon Ball <gordon@chronitis.net>  Fri, 30 Sep 2022 21:44:05 +0000
