=== debian/control ===
--- 
+++ 
@@ -3,16 +3,18 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
+               dh-python,
                cmake,
                pkg-config,
                libzmq3-dev,
-               xeus-dev (>= 1.0~),
+               xeus-dev (>= 2.0~),
                xtl-dev (>= 0.7~),
                nlohmann-json3-dev (>= 3.6.1~),
-               pybind11-dev (>= 2.2.4~),
+               pybind11-dev (>= 2.10.3~),
                pybind11-json-dev (>= 0.2.8~),
                python3-dev,
-Standards-Version: 4.5.0
+               python3-setuptools,
+Standards-Version: 4.6.2
 Section: science
 Homepage: https://github.com/jupyter-xeus/xeus-python
 Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
@@ -49,12 +51,20 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python3-jedi,
-         python3-pygments,
-Recommends: python3-ipython
+         python3-xeus-python-shell,
 Description: Native jupyter kernel for python (binary)
  xeus-python uses the xeus library to provide a high-performance,
  native kernel for running python code in the jupyter notebook,
  or other frontends using the jupyter messaging protocol.
  .
  This package contains the xpython executable and jupyter kernel configuration.
+
+Package: python3-xeus-python-shell
+Architecture: all
+Depends: ${python3:Depends}, ${misc:Depends}
+Description: Native jupyter kernel for python (python library)
+ xeus-python uses the xeus library to provide a high-performance,
+ native kernel for running python code in the jupyter notebook,
+ or other frontends using the jupyter messaging protocol.
+ .
+ This package contains the python library used for the shell.
