=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
	dh_auto_configure -D xeus-python-shell --buildsystem pybuild

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -D xeus-python-shell --buildsystem pybuild

override_dh_auto_install:
	dh_auto_install
	dh_auto_install -D xeus-python-shell --buildsystem pybuild
